/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Googlebar for Mozilla.
 *
 * The Initial Developer of the Original Code is Andy Edmonds.
 * Portions created by the Initial Developer are Copyright (C) 2001
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Andy Boughton
 *  Andrew Houghton
 *  John Woods
 *  Bernd Kuemmerlen 	
 *  Robert Mulcahy
 *  Alfred Kayser
 *  Reflex
 *  Gary Turnbull
 *  Raj Bhaskar
 *  Joachim Thewes
 *  Henrik Gemal
 *  Robert Fernandes
 *  Joe Chellman
 *  Franki Cheung
 *  Alban Fonrouge
 *  Martin Hassman
 *  Ufuk Kayserilioglu
 *  Yoni Gilad 
 *  Tim Schmidt
 *  timeless
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var altAction, altCtrlAction, altShiftAction, ctrlAction, ctrlShiftAction, noneAction, shiftAction;
var altLocation, altCtrlLocation, altShiftLocation, ctrlLocation, ctrlShiftLocation, noneLocation, shiftLocation;

var boolCritSelected, ggb_loaded, win, hkeytgl, googlebarRemoveNow;
var loading = boolCritSelected = ggb_loaded = win = hkeytgl = googlebarRemoveNow = false;
var openerUpdated = false;

var critIgnoreFocus = false;
var critIgnoreClick = false;
var ignoreUpDir = false;
var ignoreUniv = false
var populateUniv = false;

var n = 0;
var term = '';

var inFirebird = false ; // Are we in Firebird, or Mozilla.

var arrDeckActs = [
  "default", "site", "lucky", "groups", "directory", "images", "news",
  "USA", "Catalog", "dictionary", "glossary", "mac", "bsd", "linux",
  "microsoft", "webquotes", "viewer", "stocks", "froogle", "university"
];

var arrDeckLocs = [
  "Same Window", "New Tab", "New Window"
];

var cntrySfxs = new Array(85);
var cntry2Srch, cntry2SrchIx;

var cntryNewsSfxs = new Array(10);
var cntryNews2Srch, cntryNews2SrchIx;

// country domain override - for features like translate which need to use the USA site
var onlyInUSA = "com";

// the option flags that we are going to use to use google labs instead of
// the regular google site for searching
var labsOption = false;

// the option flags that we are going to save search history across browser sessions
var autoSearchOption = false;
var historyOption = true;
var historyLoaded = false;
var maxHistCnt;
var sep = "||";

var saveLastOption = false;
var hideMenuOption = false;
var queryStringOption = false;
var sortByDate = false;

var prefService = Components.classes["@mozilla.org/preferences-service;1"]
                            .getService(Components.interfaces.nsIPrefService);

var pref = prefService.getBranch(null); // preferences root node, is it used? JW.
var prefRoot = prefService.getBranch(null); // preferences root node
var gbPref = prefService.getBranch("googlebar."); // preferences googlebar node

// Search component
var gFinder = Components.classes["@mozilla.org/embedcomp/rangefind;1"].createInstance()
                        .QueryInterface(Components.interfaces.nsIFind);

var stdUrl = Components.classes["@mozilla.org/network/standard-url;1"].createInstance();
stdUrl = stdUrl.QueryInterface(Components.interfaces.nsIURL);

// DOMRange used during highlighting
var searchRange;
var startPt;
var endPt;

// Is the highlight active ?
var gbHighlightOn = false;

// What was the term used for the highlighting ?
var gHighlightString = "";

// Save selection during highlighting
var gSelection = null;
var gSaveSelection = null;

// Colors for highlighting
var termColor = new Array("yellow", "lightpink", "aquamarine", "darkgoldenrod", "darkseagreen", "lightgreen", "rosybrown", "seagreen", "chocolate", "violet");

// Remember the last focused element for stateful toggling
var gStatefulPrevFocus = null;

// Array for storing last Google search results
// (used by back/fwd result navigation stuff)
var lastResults = new Array(0);
var lastGoogle = null;

var university = null;
var universityName = null;

///////////////////////////////////////////////////////////////////////////////
/////////////////////////////////// Init //////////////////////////////////////

function googlebarDisplayCheck()
{
    // make sure that we are loading the preferences
    googlebarInitPrefs();

    if (!historyLoaded) {
        historyLoaded = true;

        if (historyOption) {
            googlebarInitHistory();
        }
        else {
            gbPref.setCharPref("history", "");
        }
    }

    if (gbHighlightOn) {
        setTimeout("googlebarRefreshHighlight()", 100);
    }

    if (populateUniv) {
        reallyUpdateUniv();
    }

    googlebarLoadResults();
    googlebarCheckNavigation();
    googlebarUpdateCriteriaDropmarker();
}

function googlebarUpdateCriteriaDropmarker(prefValue)
{
    var mainDoc = document;
    var critMenu = mainDoc.getElementById("googlebarCriteria");

    /* If were are in the preferences then we need to update the document, and get the preference value */
    if (!critMenu) {
        mainDoc = top.opener.document;
        critMenu = mainDoc.getElementById("googlebarCriteria");
        historyOption = prefValue;
    }

    if (!critMenu) {
        alert("Error: Couldn't locate googlebarCriteria element in document.");
    }
    else {
        var critMenuDrop = mainDoc.getAnonymousElementByAttribute(critMenu, "class", "menulist-dropmarker");
        critMenuDrop.setAttribute("hidden", !historyOption);
    }

    // clear the history when it was switched off
    if (!historyOption) {
      googlebarClearHistory();
    }
}

function googlebarInitPrefs()
{
    googlebarReadPref();

    // FIX-ME:  Why are all of these variables set here?
    // Is this not a duplication of what happens in the googlebarReadPref method?
    // Commenting this section out until it is determined why it is necessary.
/*
    labsOption = false;
    if (gbPref.getBoolPref("searchoption")) {
        labsOption = gbPref.getBoolPref("searchoption");
    }

    autoSearchOption = false;
    if (gbPref.getBoolPref("autosearchoption")) {
        autoSearchOption = gbPref.getBoolPref("autosearchoption");
    }

    historyOption = false;
    if (gbPref.getBoolPref("historyoption")) {
        historyOption = gbPref.getBoolPref("historyoption");
    }

    saveLastOption = false;
    if (gbPref.getBoolPref("savelastoption")) {
        saveLastOption = gbPref.getBoolPref("savelastoption");
    }

    hideMenuOption = false;
    if (gbPref.getBoolPref("hidemenuoption")) {
        hideMenuOption = gbPref.getBoolPref("hidemenuoption");
    }

    queryStringOption = false;
    if (gbPref.getBoolPref("querystringoption")) {
        queryStringOption = gbPref.getBoolPref("querystringoption");
    }
*/
}

function googlebarInitHistory()
{
    var historyArray = new Array();
    try {
      var nsISupportsString = Components.interfaces.nsISupportsWString ||
        Components.interfaces.nsISupportsString;
      var string = gbPref.getComplexValue("history", nsISupportsString).data;        
      historyArray = string.split("||");
    }
    catch(e) {
        dump("\nHistory init failure caught\n" + e);
    }

    // iterate over the saved history items and add them to the list
    // and make sure to use the second paramenter of the addToHistory
    // function so that we don't add it to the saved preference again
    for (var i = 0; i < historyArray.length; i++) {
        if (historyArray[i]) {
            googlebarAddToHistory(historyArray[i], true);
        }
    }
}

function googlebarReadPref() 
{
    /***********************************
       Modifier Key Action Preferences
     ***********************************/
     
    try { 
        altAction = gbPref.getCharPref("ActionAlt");
    }
    catch(e) {
        gbPref.setCharPref("ActionAlt", "0");  // Default
    }
    
    try {
        altCtrlAction = gbPref.getCharPref("ActionAltCtrl");
    }
    catch(e) {
        gbPref.setCharPref("ActionAltCtrl", "0");  // Default
    }
    
    try {
        altShiftAction = gbPref.getCharPref("ActionAltShift");
    }
    catch(e) {
        gbPref.setCharPref("ActionAltShift", "0");  // Default
    }      
    
    try {
        ctrlAction = gbPref.getCharPref("ActionCtrl");
    }
    catch(e) {
        gbPref.setCharPref("ActionCtrl", "0");  // Default
    } 
        
    try {
        ctrlShiftAction = gbPref.getCharPref("ActionCtrlShift");
    }
    catch(e) {
        gbPref.setCharPref("ActionCtrlShift", "0");  // Default
    }      
        
    try {
        noneAction = gbPref.getCharPref("ActionNone");
    }
    catch(e) {
        gbPref.setCharPref("ActionNone", "0");  // Default
    }        
        
    try {
        shiftAction = gbPref.getCharPref("ActionShift");
    }
    catch(e) {
        gbPref.setCharPref("ActionShift", "0");  // Default
    }

    /*************************************
       Modifier Key Location Preferences
     *************************************/

    try {
        altLocation = gbPref.getCharPref("LocationAlt");
    }
    catch(e) {
        gbPref.setCharPref("LocationAlt", "0");  // Same Window
        altLocation = gbPref.getCharPref("LocationAlt");
    }

    try {
        altCtrlLocation = gbPref.getCharPref("LocationAltCtrl");
    }
    catch(e) {
        gbPref.setCharPref("LocationAltCtrl", "0");  // Same Window
        altCtrlLocation = gbPref.getCharPref("LocationAltCtrl");
    }

    try {
        altShiftLocation = gbPref.getCharPref("LocationAltShift");
    }
    catch(e) {
        gbPref.setCharPref("LocationAltShift", "0");  // Same Window
        altShiftLocation = gbPref.getCharPref("LocationAltShift");
    }
   
    try {
        ctrlLocation = gbPref.getCharPref("LocationCtrl");
    }
    catch(e) {
        gbPref.setCharPref("LocationCtrl", "1");  // New Tab
        ctrlLocation = gbPref.getCharPref("LocationCtrl");
    }

    try {
        ctrlShiftLocation = gbPref.getCharPref("LocationCtrlShift");
    }
    catch(e) {
        gbPref.setCharPref("LocationCtrlShift", "1");  // New Tab
        ctrlShiftLocation = gbPref.getCharPref("LocationCtrlShift");
    }

    try {
        noneLocation = gbPref.getCharPref("LocationNone");
    }
    catch(e) {
        gbPref.setCharPref("LocationNone", "0");  // Same Window
        noneLocation = gbPref.getCharPref("LocationNone");
    }
    
    try {
        shiftLocation = gbPref.getCharPref("LocationShift");
    }
    catch(e) {
        gbPref.setCharPref("LocationShift", "2");  // New Window
        shiftLocation = gbPref.getCharPref("LocationShift");
    }

    /****************************************
       Domain Specific Preferences (Search)
     ****************************************/

    try {
        cntry2SrchIx = gbPref.getIntPref("country2Search");
    }
    catch(e) {
        gbPref.setIntPref("country2Search", document.getElementById("bundle_googlebar").getString("gb.country_default"));
        cntry2SrchIx = gbPref.getIntPref("country2Search");
    }
            
    cntrySfxsInit();
    cntry2Srch = cntrySfxs[cntry2SrchIx]; 

    /**************************************
       Domain Specific Preferences (News)
     **************************************/

    try {
        cntryNews2SrchIx = gbPref.getIntPref("countryNews2Search");
    }
    catch(e) {
        gbPref.setIntPref("countryNews2Search", document.getElementById("bundle_googlebar").getString("gb.news.country_default"));
        cntryNews2SrchIx = gbPref.getIntPref("countryNews2Search");
    }
            
    cntryNewsSfxsInit();
    cntryNews2Srch = cntryNewsSfxs[cntryNews2SrchIx];
    
    /***********************************
       Other Miscellaneous Preferences
     ***********************************/

    try {
        autoSearchOption = gbPref.getBoolPref("autosearchoption");
    }
    catch(e) {
        gbPref.setBoolPref("autosearchoption", false); // Auto Search When History Item Selected
        autoSearchOption = gbPref.getBoolPref("autosearchoption");
    }

    try {
        cntxtmnuopt = gbPref.getBoolPref("contextmenuoption");
    }
    catch(e) {
        gbPref.setBoolPref("contextmenuoption", true);
        cntxtmnuopt = gbPref.getBoolPref("contextmenuoption");
    }

    try {
        hideMenuOption = gbPref.getBoolPref("hidemenuoption");
    }
    catch(e) {
        gbPref.setBoolPref("hidemenuoption", false); // Hide Menu Items Promoted to Buttons
        hideMenuOption = gbPref.getBoolPref("hidemenuoption");
    }

    try {
        historyOption = gbPref.getBoolPref("historyoption");
    }
    catch(e) {
        gbPref.setBoolPref("historyoption", true); // Save History    
        gbPref.setCharPref("history", "googlebar"); // History Value 
        historyOption = gbPref.getBoolPref("historyoption");
    }

    try {
        hkeytgl = gbPref.getBoolPref("hotkeySelectionToggles");
    }
    catch(e) {
        gbPref.setBoolPref("hotkeySelectionToggles", false); // mimic ctrl-L or toggle
        hkeytgl = gbPref.getBoolPref("hotkeySelectionToggles");
    }

    try {
        labsOption = gbPref.getBoolPref("searchoption");
    }
    catch(e) {
        gbPref.setBoolPref("searchoption", false); // Google Labs
        labsOption = gbPref.getBoolPref("searchoption");
    }

    try {
        maxHistCnt = gbPref.getIntPref("maxHistCnt");
    }
    catch(e) {
        gbPref.setIntPref("maxHistCnt", 10); // Maximum History Values Kept
        maxHistCnt = gbPref.getIntPref("maxHistCnt");
    }

    try {
        queryStringOption = gbPref.getBoolPref("querystringoption");
    }
    catch(e) {
        gbPref.setBoolPref("querystringoption", false); // Ignore Query String for Up Dir Button
        queryStringOption = gbPref.getBoolPref("querystringoption");
    }

    try {
        saveLastOption = gbPref.getBoolPref("savelastoption");
    }
    catch(e) {
        gbPref.setBoolPref("savelastoption", false); // Save Last Search Type
        saveLastOption = gbPref.getBoolPref("savelastoption");
    }

    try {
        sortByDate = gbPref.getBoolPref("sortByDate");
    }
    catch(e) {
        gbPref.setBoolPref("sortByDate", false); // Sort Google Search Results by Date
        sortByDate = gbPref.getBoolPref("sortByDate");
    }

    // If there was a previous university selected
    // then use that as the default, otherwise just
    // ignore it
    try {
        university = gbPref.getCharPref("university");
        universityName = gbPref.getCharPref("universityName");
        setUniv(university, universityName);
    }
    catch(e) {
      gbPref.setCharPref("university","");
      gbPref.setCharPref("universityName","");
    }

    try {
        ggb_init();
    }
    catch(e) {
    }

    try {
        setGoogleContextMenu();
    }
    catch(e) {
        dump("\nGooglebar: ReadPref: trapping  error:\n" + e);
        inFirebird = true; // It fails in current Firebird
    }

    dump("Finished ReadPrefs OK\n");
}

function ggb_init()
{
    if (!ggb_loaded) {
        window.removeEventListener("keypress",googlebarDisplayCheck,true);
        window.removeEventListener("mousemove",googlebarDisplayCheck,true);

        ggb_loaded = true;

        var element = document.getElementById("LabelsButtonItem");

        if (element.getAttribute("checked") == "true") {
            googlebarLabelsOn();
        }
        else {
            googlebarLabelsOff();
        }

        var hideExtras = !(document.getElementById("extras-box").childNodes.length > 0);

        document.getElementById("extras-box").setAttribute("hidden", hideExtras);
        document.getElementById("ExtrasButtonItem").setAttribute("hidden", hideExtras);

        googlebarSyncMenuButton("comp-menu", "lastCompSearch");
        googlebarSyncMenuButton("info-menu", "lastInfoSearch");
        googlebarSyncMenuButton("spec-menu", "lastSpecSearch");

        googlebarGoPopupMenus();
        initCustomOrder(); // this function is actually in googlebarDragAndDrop.js

        // Fix Me later this blows it in the very first run of the window init.
        // It must come after ggb_loaded is set. It seems fine after that
          
        if ("XULBrowserWindow" in window && window.XULBrowserWindow.onLocationChange && (window.XULBrowserWindow.onLocationChange != onLocationChange)) {
            window.XULBrowserWindow.__googlebar__onLocationChange = window.XULBrowserWindow.onLocationChange;
            window.XULBrowserWindow.onLocationChange = onLocationChange;
        }
    }
    else {
        if ("XULBrowserWindow" in window && window.XULBrowserWindow.onLocationChange && (window.XULBrowserWindow.onLocationChange != onLocationChange)) {
            window.XULBrowserWindow.__googlebar__onLocationChange = window.XULBrowserWindow.onLocationChange;
            window.XULBrowserWindow.onLocationChange = onLocationChange;
        }
        googlebarGoPopupMenus();
        updateUp();
    }
}

function onLocationChange(aWebProgress, aRequest, aLocation)
{
    if (aLocation)
    {
        var url = aLocation.spec;
        var terms;

        if (/^\s*http:\/\/[^\.]*\.google\..*\/[^\?]*\?.*q=([^&]*)(&.*)*/i.test(url)) {
            terms = RegExp.$1;
            terms = terms.replace(/\+?(site|cache):[^\+]*\+?/g, "");
            terms = terms.replace(/\+/g, " ");
            terms = decodeURIComponent(terms);

            var critBox = document.getElementById("googlebarCriteria");
            critBox.value = terms;

            googlebarCheckSearchbuttons();
            if (gbHighlightOn) {
                googlebarHighLightInPage("on");
            }
        } else {
          googlebarUpdateNewWindow();
          googlebarCheckSearchbuttons();
        }

        var siteBtn = document.getElementById("site-separate");

        if (/^\s*http:\/\/[^\.]*\.google\..*\/.*/i.test(url)) {
            if (/^\s*http:\/\/[^\.]*\.google\..*\/[^\?]*\?.*q=site:([^&]*)(&.*)*/i.test(url)) {
                siteBtn.setAttribute("disabled", false);
            }
            else {
                siteBtn.setAttribute("disabled", true);
            }
        }
        else {
            siteBtn.setAttribute("disabled", false);
        }

        googlebarLoadResults();
        googlebarCheckNavigation();
        updateUp();
    }

    return window.XULBrowserWindow.__googlebar__onLocationChange(aWebProgress, aRequest, aLocation);
}

function googlebarCustomNavigation()
{
    if (!window._content.document) {
        return;
    }

    var url = window._content.document.location;
    var doc = window._content.document.documentElement;
    var aElems = doc.getElementsByTagName("A");

    var i = 0;
    var count = 0;

    for (i = 0; i < aElems.length; i++) {
        if (getAnchorURL(aElems[i], url)) {
            count++;
        }
    }

    if (count > 0) {
        lastResults = new Array(count);
    }
    else {
        lastResults = new Array(0);
        return;
    }

    count = 0;

    for (i = 0; i < aElems.length; i++) {
        if (getAnchorURL(aElems[i], url)) {
            lastResults[count] = getAnchorURL(aElems[i], url);
            count++;
        }
    }

    // alert("Set last results to\n" + lastResults.join("\n"));

    // also populate the last google result and set up the button appropriately
    lastGoogle = url;

    var lastBtn = document.getElementById("last-button");
    lastBtn.removeAttribute("oncommand");
    lastBtn.setAttribute("disabled", false);
    lastBtn.setAttribute("onclick", "if (event.button == 1) { navGo(event, '" + url + "') }");
    lastBtn.setAttribute("oncommand", "navGo(event, '" + url + "');");
}

function getAnchorURL(element, baseURL)
{
    var href = element.getAttribute("href");
    var url;

    if (!href || /^\s*mailto:/i.test(href)) {
        return null;
    }
    else {
        stdUrl.spec = baseURL;
        url = stdUrl.resolve(href);
    }

    if (url) {
        return url;
    }
    else {
        alert("Don't know how to handle this URL:\n" + href);
        return null;
    }
}

function googlebarLoadResults()
{
    if (!window._content.document) {
        return;
    }

    var url = window._content.document.location;
    if (/^\s*http:\/\/[^\.]*\.google\..*\/[^\?]*\?.*q=([^&]*)(&.*)*/i.test(url)) {
        // Must have just loaded a google query result page
        // so lets repopulate the array of last results.
        //
        // In a Google query result page all of the results
        // are under HTML paragraph elements "P" with a class
        // attribute of "g".  The first URL (child element "A")
        // is the actual result that we care about.
        var doc = window._content.document.documentElement;
        var pElems = doc.getElementsByTagName("P");
        var aElems;

        var i = 0;
        var count = 0;

        for (i = 0; i < pElems.length; i++) {
            if (pElems[i].getAttribute("class") == "g") {
                count++;
            }
        }

        if (count > 0) {
            lastResults = new Array(count);
        }
        else {
            lastResults = new Array(0);
            return;
        }

        count = 0;

        for (i = 0; i < pElems.length; i++) {
            if (pElems[i].getAttribute("class") == "g") {
                aElems = pElems[i].getElementsByTagName("A");
                if (aElems.length > 0) {
                    lastResults[count] = aElems[0].getAttribute("href");
                }
                count++;
            }
        }
        // alert("Set last results to\n" + lastResults.join("\n"));

        // also populate the last google result and set up the button appropriately
        lastGoogle = url;

        var lastBtn = document.getElementById("last-button");
        lastBtn.removeAttribute("oncommand");
        lastBtn.setAttribute("disabled", false);
        lastBtn.setAttribute("onclick", "if (event.button == 1) { navGo(event, '" + url + "') }");
        lastBtn.setAttribute("oncommand", "navGo(event, '" + url + "');");
    }
}

function googlebarCheckNavigation()
{
    if (!window._content.document) {
        return;
    }

    var currLoc = window._content.document.location;
    var currLocMatch = -1;

    for (var i = 0; i < lastResults.length; i++) {
        if (lastResults[i] == currLoc) {
            currLocMatch = i;
            break;
        }
    }

    var prevBtn = document.getElementById("prev-button");
    var nextBtn = document.getElementById("next-button");

    // the oncommand attribute must be REMOVED because if
    // the button is disabled it should take no action and
    // if it is already set you can't just set it again,
    // for some reason that has no effect so you have to
    // remove the attribute and add it again
    prevBtn.removeAttribute("oncommand");
    nextBtn.removeAttribute("oncommand");

    // if we didn't find a match then disable both buttons and return
    if (currLocMatch < 0) {
        prevBtn.setAttribute("disabled", true);
        prevBtn.setAttribute("tooltiptext", document.getElementById("bundle_googlebar").getString("gb.button.nav.prev.tooltip"));
        nextBtn.setAttribute("disabled", true);
        nextBtn.setAttribute("tooltiptext", document.getElementById("bundle_googlebar").getString("gb.button.nav.next.tooltip"));
        return;
    }
    var loc;

    // previous navigation
    if (currLocMatch == 0) {
        prevBtn.setAttribute("disabled", true);
        prevBtn.setAttribute("tooltiptext", document.getElementById("bundle_googlebar").getString("gb.button.nav.prev.tooltip"));
    }
    else {
        loc = lastResults[currLocMatch - 1];
        prevBtn.setAttribute("disabled", false);
        prevBtn.setAttribute("tooltiptext", document.getElementById("bundle_googlebar").getString("gb.button.nav.prev.tooltip") + " - " + loc);
        prevBtn.setAttribute("onclick", "if (event.button == 1) { navGo(event, '" + loc + "') }");
        prevBtn.setAttribute("oncommand", "navGo(event, '" + loc + "');");
    }

    // next navigation
    if (currLocMatch == lastResults.length - 1) {
        nextBtn.setAttribute("disabled", true);
        nextBtn.setAttribute("tooltiptext", document.getElementById("bundle_googlebar").getString("gb.button.nav.next.tooltip"));
    }
    else {
        loc = lastResults[currLocMatch + 1];
        nextBtn.setAttribute("disabled", false);
        nextBtn.setAttribute("tooltiptext", document.getElementById("bundle_googlebar").getString("gb.button.nav.next.tooltip") + " - " + loc);
        nextBtn.setAttribute("onclick", "if (event.button == 1) { navGo(event, '" + loc + "') }");
        nextBtn.setAttribute("oncommand", "navGo(event, '" + loc + "');");
    }
}

function navGo(event, addy)
{
    googlebarDoAction(addy, googlebarGetLocFromEvent(event));
}

///////////////////////////////////////////////////////////////////////////////
///////////////////////////////// Main Search /////////////////////////////////

function googlebarAutoSearch(event)
{
    googlebarInitPrefs();
    if (autoSearchOption) {
        googlebarSearch(event);
    }
}

function googlebarSearch(event, searchType, searchParams)
{
    var win = window._content.document;
    var searchURL;

    // recover any prefence changes like country and modifiers immediately
    googlebarInitPrefs();

    if (!searchType) {
        searchType = googlebarGetActFromEvent(event);
    }

    if (!loading) {
        googlebarClearTerms();
        var critBox = document.getElementById("googlebarCriteria");
        googlebarAddTerm(critBox.value);
        googlebarAddToHistory(critBox.value);

        var crit = googlebarBuildURI(critBox.value);

        switch(searchType) {
    
        case "site":
            var searchHost;

            // If you are on a site search result then reuse that site for the next search,
            // otherwise use the current window location shown in the browser

            if (/^\s*http:\/\/[^\.]*\.google\..*\/[^\?]*\?.*q=site:([^\+]*)([^&]*)(&.*)*/i.test(win.location.href)) {
                searchHost = RegExp.$1;
            }
            else {
                searchHost = win.location.hostname;
            }

            searchURL = 'http://www.google.' + cntry2Srch + '/search?sourceid=mozclient&ie=utf-8&oe=utf-8&q=site:' + searchHost + '+' + crit;
            break;
    
        case "backwards":
            searchURL = 'http://www.google.' + cntry2Srch + '/search?sourceid=mozclient&q=link:' + googlebarInfoLocation();
            break;
    
        case "similar":
            searchURL = 'http://www.google.' + cntry2Srch + '/search?sourceid=mozclient&q=related:' + googlebarInfoLocation();
            break;
    
        case "translate":
            searchURL = 'http://translate.google.' + onlyInUSA + '/translate?sourceid=mozclient&u=' + googlebarInfoLocation();
            break;

        case "cachelink":
            if (!searchParams) {
              searchParams = 'http://www.google.com/';
            }
            searchURL = 'http://www.google.' + cntry2Srch + '/search?q=cache:' + searchParams;
            break;
    
        case "cache":
            searchURL = 'http://www.google.' + cntry2Srch + '/search?q=cache:' + googlebarInfoLocation();
            break;
    
        case "images":
            searchURL = 'http://images.google.' + cntry2Srch + '/images?sourceid=mozclient&ie=utf-8&oe=utf-8&q=' + crit;
            break;
    
        case "groups":
            searchURL = 'http://groups.google.' + cntry2Srch + '/groups?sourceid=mozclient&ie=utf-8&oe=utf-8&q=' + crit;
            break;
    
        case "directory":
            searchURL = 'http://www.google.' + cntry2Srch + '/search?sourceid=mozclient&ie=utf-8&oe=utf-8&q=' + crit + '&cat=gwd/Top&sa=N&tab=gd';
            break;
    
        case "lucky":
            searchURL = 'http://www.google.' + cntry2Srch + '/search?sourceid=mozclient&ie=utf-8&oe=utf-8&q=' + crit + '&btnI=I%27m+Feeling+Lucky';
            break;
    
        case "USA":
            searchURL = 'http://www.google.' + onlyInUSA + '/unclesam?sourceid=mozclient&restrict=unclesam&ie=utf-8&oe=utf-8&q=' + crit;
            break;
    
        case "Catalog":
            searchURL = 'http://catalogs.google.' + onlyInUSA + '/catalogs?sourceid=mozclient&ie=utf-8&oe=utf-8&q=' + crit;
            break;
    
        case "bsd":
            searchURL = 'http://www.google.' + cntry2Srch + '/bsd?restrict=bsd&ie=utf-8&oe=utf-8&q=' + crit;
            break;
    
        case "microsoft":
            searchURL = 'http://www.google.' + cntry2Srch + '/microsoft?sourceid=mozclient&hq=microsoft&restrict=microsoft&ie=utf-8&oe=utf-8&q=' + crit;
            break;
    
        case "mac":
            searchURL = 'http://www.google.' + cntry2Srch + '/mac?sourceid=mozclient&restrict=mac&ie=utf-8&oe=utf-8&q=' + crit;
            break;
    
        case "linux":
            searchURL = 'http://www.google.' + cntry2Srch + '/linux?sourceid=mozclient&restrict=linux&ie=utf-8&oe=utf-8&q=' + crit;
            break;
    
        case "news":
            searchURL = 'http://news.google.' + onlyInUSA + '/news?sourceid=mozclient&ie=utf-8&oe=utf-8&' + cntryNews2Srch + '&q=' + crit;
            break;

        case "answers":
            searchURL = 'http://answers.google.' + onlyInUSA + '/answers/main?cmd=search&qtype=all&q=' + crit;
            break;
    
        case "webquotes":
            searchURL = 'http://labs.google.' + onlyInUSA + '/cgi-bin/webquotes?num_quotes=3&q=' + crit + '&btnG=Google+WebQuotes+Search&show_titles=1&bold_links=1&snippet_threshold=3&ie=utf-8&oe=utf-8';
            break;
    
        case "stocks":
            searchURL = 'http://www.google.' + cntry2Srch + '/search?sourceid=mozclient&ie=utf-8&oe=utf-8&q=stocks:' + crit;
            break;
    
        case "viewer":
            searchURL = 'http://labs1.google.' + onlyInUSA + '/cgi-bin/gviewer.cgi?q=' +crit + '&btnG=Google+Search&ie=utf-8&oe=utf-8';
            break;
    
        case "froogle":
            searchURL = 'http://froogle.google.' + onlyInUSA + '/froogle?q=' + crit + '&btnG=Froogle+Search&ie=utf-8&oe=utf-8';
            break;
    
        case "dictionary":
            searchURL = 'http://www.dictionary.com/cgi-bin/dict.pl?term=' + crit;
            break;
    
        case "glossary":
            // Glossary search doesn't appear to be valid for countries outside the US
            // searchURL = 'http://labs.google.' + cntry2Srch + '/glossary?q=' + crit;
            searchURL = 'http://labs.google.' + onlyInUSA + '/glossary?q=' + crit;
            break;
    
        case "university":
            if (!university) {
                alert(document.getElementById("bundle_googlebar").getString("gb.button.univ.none"));
                return;
            }
            if (universityName == "All Universities") {
                searchURL = university + '&q=' + crit;
            }
            else {
                searchURL = university + '?q=' + crit;
            }
            break;
    
        default:
            if (labsOption) {
                searchURL = 'http://labs.google.com/cgi-bin/keys?q=';
            }
            else {
                searchURL = 'http://www.google.' + cntry2Srch + '/search?sourceid=mozclient&ie=utf-8&oe=utf-8&q=';
            }
            searchURL += crit;
            break;

        }

        if (sortByDate)
          searchURL = searchURL.replace('sourceid=mozclient','sourceid=mozclient&scoring=d');

        googlebarDoAction(searchURL, googlebarGetLocFromEvent(event));
    }
}

function googlebarGetLocFromEvent(event)
{
    // alert("ALT : " + event.altKey + "\nCTRL : " + event.ctrlKey + "\nSHIFT : " + event.shiftKey + "\n");
    if (event.button == 1) {
        return "New Tab";
    }
    if (event.altKey) {
        if (event.ctrlKey) {
            return arrDeckLocs[altCtrlLocation];
        }
        else if (event.shiftKey) {
            return arrDeckLocs[altShiftLocation];
        }
        else {
            return arrDeckLocs[altLocation];
        }
    }
    else if (event.ctrlKey) {
        if (event.shiftKey) {
            return arrDeckLocs[ctrlShiftLocation];
        }
        else {
            return arrDeckLocs[ctrlLocation];
        }
    }
    else if (event.shiftKey) {
        return arrDeckLocs[shiftLocation];
    }
    else {
        return arrDeckLocs[noneLocation];
    }
}

function googlebarGetActFromEvent(event)
{
    if (event.altKey) {
        if (event.ctrlKey) {
            return arrDeckActs[altCtrlAction];
        }
        else if (event.shiftKey) {
            return arrDeckActs[altShiftAction];
        }
        else {
            return arrDeckActs[altAction];
        }
    }
    else if (event.ctrlKey) {
        if (event.shiftKey) {
            return arrDeckActs[ctrlShiftAction];
        }
        else {
            return arrDeckActs[ctrlAction];
        }
    }
    else if (event.shiftKey) {
        return arrDeckActs[shiftAction];
    }
    else {
        return arrDeckActs[noneAction];
    }
}

function googlebarInfoLocation()
{
    var win = window._content.document;
    var location;

    if (/^\s*http:\/\/[^\.]*\.google\..*\/[^\?]*\?.*(q=link:|q=related:|q=site:|u=)([^\+]*)([^&]*)(&.*)*/i.test(win.location.href)) {
        location = RegExp.$2;
    }
    else if (/^\s*http:\/\/.*\/[^\?]*\?.*q=cache:([^\+]*)([^&]*)(&.*)*/i.test(win.location.href)) {
        location = RegExp.$1;
    }
    else {
        location = win.location;
    }
    
    return escape(location);
}

function googlebarDoAction(searchURL, location)
{
    switch(location) {

    case "Same Window":
        window._content.document.location = searchURL;

        // if we are using google labs for the search, then we
        // want to make sure that we return the focus to the
        // main navigator window
        if (labsOption) {
            window.frames[0].focus();
        }
        else {
            window.content.focus();
        }
        break;

    case "New Tab":
        var browser = getBrowser();
        var tab = browser.addTab(searchURL, getReferrer(document));
        window.content.focus();

        // Hook this up -- have we init'ed prefRoot
        if (!prefRoot.getBoolPref("browser.tabs.loadInBackground")) {
            browser.selectedTab = tab;
        }
        break;

    case "New Window":
        window.open(searchURL);
        break;

    default:
        alert(document.getElementById("bundle_googlebar").getString("gb.error"));
        break;

    }
}

///////////////////////////////////////////////////////////////////////////////
/////////////////////////////////// Support ///////////////////////////////////

function googlebarEscape(term)
{
    // we need to handle both '/' and '+' specially
    term = encodeURIComponent(term);
    return term.replace(/\+/g,"%2B").replace(/\//g,"%2F");
}

function googlebarBuildURI(criteria)
{
    var terms = criteria.split(" ");
    var uri = "";

    for (var i = 0; i < terms.length; i++) {
        if (i > 0) {
            uri += "+";
        }
        uri += googlebarEscape(terms[i]);
    }
    return uri;
}

function googlebarPaste(event)
{
    var critBox = document.getElementById("googlebarCriteria");
    var textBox;

    // attempt to grab selected text from the current document (tab)
    var text = _content.document.getSelection();

    // if nothing selected in the document then perhaps there is a
    // selection contained within a frame of the current document
    if (!text) {
        for (var i = 0; i < _content.frames.length; i++) {
            text = _content.frames[i].document.getSelection();
            if (text) break;
        }
    }

    // if still no text has been found then perhaps something in
    // the the location text box has been selected
    if (!text) {
        textBox = window.document.getElementById("urlbar");
        if (textBox.selectionStart >= 0) {
            text = textBox.value.substring(textBox.selectionStart, textBox.selectionEnd);
        }
    }

    // if still no text has been found then perhaps something in
    // the the criteria box has been selected - not sure why you
    // would want to search on something already in the criteria
    // box but hey, who am I to criticize
    // hmmm, here is a far fetched use case so I'll leave this code
    // for now - someone may have multiple terms in the criteria
    // box and may want to only search on one of them, highlighting
    // that single term and then shift+click on highlight search
    // button would search on that term alone - not likely, but a use case
    if (!text) {
        textBox = document.getElementById("googlebarCriteria");
        if (textBox.selectionStart >= 0) {
            text = textBox.value.substring(textBox.selectionStart, textBox.selectionEnd);
        }
    }

    // if we have found some selected text then set the criteria
    // box to that value and reset the search term buttons,
    // otherwise display an error message via an alert
    if (text) {

        // if there was no previous text or the shift key was pressed
        // then change the value to the selected text, otherwise append
        // the text to the end of what was already there.  after that
        // then the search term buttons need to be updated
        if (!critBox.value || event.shiftKey) {
            critBox.value = text;
        }
        else {
            critBox.value += " " + text;
        }

        googlebarCheckSearchbuttons();

        if (event.ctrlKey) {
            googlebarSearch(event);
        }
    }
    else {
        alert(document.getElementById("bundle_googlebar").getString("gb.select_before"));
    }
}

function googlebarFindTerms(criteria)
{
    // quotes only matter when preceded by a space or a quote.
    var terms = new Array();
    var val;

    var inQuote = false;
    var haveTerm = false;

    var currPtr = 0; // the start of the current term
    var prevChar = ' ';  // the char we last saw

    for (var index = 0; index < criteria.length; index++) {
        var currChar = criteria.charAt(index);

        switch (currChar) {
          
        case ' ':
        case '+':
        case '(':
        case ')':
        case '~':
	//double-byte space
	case decodeURIComponent('%E3%80%80'):
          // these characters do not occur on the search term buttons, 
          // except in quoted phrases
          if (!inQuote && haveTerm) {
            val = TrimString(criteria.substring(currPtr, index));
            if (!isIn(terms, val)) {
              if (val != 'OR' && val[0] != '-') {
                terms.push(val);
              }
            }
            haveTerm = false;
          }
          break;
          
        case '"':
          // phrases (enclosed in "") should result in only one button
          if (!inQuote) {
              if (haveTerm) {
                  val = TrimString(criteria.substring(currPtr, index));
                  if (!isIn(terms, val)) {
                      terms.push(val);
                  }
                  haveTerm = false;
              }

              // any of the discardable characters can occur before a phrase
              if ((prevChar == ' ') 
                  || (prevChar == '"')
                  || (prevChar == '(')
                  || (prevChar == ')')
                  || (prevChar == '+')
                  || (prevChar == '~')
                ) {
                  inQuote = true;
              }
          }
          else {
              if (haveTerm) {
                  val = TrimString(criteria.substring(currPtr, index));
                  if (!isIn(terms, val)) {
                      terms.push(val);
                  }
                  haveTerm = false;
                  inQuote = false;
              }
          }
          break;
          
        default:
            if (!haveTerm) {
                haveTerm = true;
                currPtr = index;
            }
        }
        prevChar = currChar;
    }
    val = TrimString(criteria.substring(currPtr, index));

    if (haveTerm && !isIn(terms, val) ) {
      // remove special prefixes
      val = val.replace(/(cache|link|related|stocks|site|allintitle|intitle|allinurl|inurl|filetype|group):/,'');
      
      if (val != 'OR' && val[0] != '-') {
        terms.push(val);
      }
    }
    
    return terms;
}

function googlebarAddToHistory(term, ignorePref)
{
    // This function adds the string "term" to the search
    // history *only* if it is not already there
    var critBox = document.getElementById("googlebarCriteria");
    var historyMenu = critBox.childNodes.item(0);

    var numHistItems = historyMenu.childNodes.length;
    var alreadyInHist = false;
    var i = 0;

    // iterate over the current history and check if the term is
    // already there
    for (i = 0; i < numHistItems; i++) {
        if (term == historyMenu.childNodes[i].getAttribute("label")) {
            alreadyInHist = true;
        }
    }

    // add to history
    if (!alreadyInHist) {
        var myMenuItem = document.createElement("menuitem");
        myMenuItem.setAttribute("label", term);
        myMenuItem.setAttribute("oncommand", "googlebarAutoSearch(event);");

        if (numHistItems <= 0) {
            historyMenu.appendChild(myMenuItem);
        }
        else {
            historyMenu.insertBefore(myMenuItem, historyMenu.childNodes[0]);
        }

        numHistItems++;

        if (!ignorePref) {
            googlebarAddToHistoryPref(term);
        }

        // if too many items have been added then remove extra items from the bottom
        if (numHistItems > maxHistCnt) {
            var numToRemove = numHistItems - maxHistCnt;

            // iterate over the current history and remove any extraneous items
            for (i = 1; i <= numToRemove; i++) {
                historyMenu.removeChild(historyMenu.lastChild);
            }
            googlebarRefreshHistoryPref();
        }
    }
}

function googlebarAddToHistoryPref(term)
{
    // This function adds the string "term" to the search
    // history preference *only* if the option to save
    // search history is selected.
    //
    // This function should only be called after it has
    // been established that this item is not already
    // in the list of items (see googlebarAddToHistory)
    // otherwise there may be duplicate items added to
    // the history.  There could be a check to see whether
    // it exists here as well to prevent this problem
    // but it doesn't appear to be necessary at this point
    // since this function is only called from within the
    // googlebarAddToHistory function.
    //
    // Another potential problem that should be addressed
    // is to check whether or not the || delimeter is
    // contained in the search term, if it is then it will
    // cause a problem when the history is reloaded.

    var nsISupportsString;

    if (historyOption) {
        var sHistory = "";
        var sSearch = term;

        if (!sSearch) {
            return;
        }

        try {
            nsISupportsString = Components.interfaces.nsISupportsWString ||
            Components.interfaces.nsISupportsString;
            sHistory = gbPref.getComplexValue("history", nsISupportsString).data;
        }
        catch(e) {
            dump("\nHistory get pref err\n" + e );
            sHistory = gbPref.setCharPref("history", "placeholder");
        }

        if (sHistory) {
            sHistory = sHistory + sep + sSearch;
        }
        else {
            sHistory = sSearch;
        }

        // This appears to be duplicated code from the try block above.
        // Going to comment this out until it is determined that it is
        // actuall necessary to have it.
        /*
        nsISupportsString = Components.interfaces.nsISupportsWString ||
          Components.interfaces.nsISupportsString;
        */

        var string = (Components.classes['@mozilla.org/supports-wstring;1']) ?
          Components.classes['@mozilla.org/supports-wstring;1']
          .createInstance(nsISupportsString) :
          Components.classes['@mozilla.org/supports-string;1']
          .createInstance(nsISupportsString) ;
        string.data =  sHistory;
        gbPref.setComplexValue("history", nsISupportsString, string);
    }
}

function googlebarRefreshHistoryPref()
{
    var critBox = document.getElementById("googlebarCriteria");
    var historyMenu = critBox.childNodes.item(0);
    var numHistItems = historyMenu.childNodes.length;

    // snyc up the history preference with the new list
    gbPref.setCharPref("history", "");

    for (i = numHistItems - 1; i >= 0; i--) {
        googlebarAddToHistoryPref(historyMenu.childNodes[i].getAttribute("label"));
    }
}

function googlebarClearHistory()
{
    // This function removes all items from the search
    // history (both history pref and popup menu)
    var critBox = document.getElementById("googlebarCriteria");

    // If called from the prefs, we need to get the main document
    // first.
    if (!critBox) {
      mainDoc = top.opener.document;
      critBox = mainDoc.getElementById("googlebarCriteria");
    }
    if (!critBox)
      alert("Error: Couldn't locate googlebarCriteria element in document. Please report on http://googlebar.mozdev.org/bugs/");
    
    var historyMenu = critBox.childNodes.item(0);
    var numHistItems = historyMenu.childNodes.length;


    // iterate over the current history and remove each item
    for (var i = numHistItems - 1; i >= 0; i--) {
        historyMenu.removeChild(historyMenu.childNodes[i]);
    }

    // next clear all the term buttons, the input field
    // (by setting selected index to -1), and history pref
    googlebarClearTerms();
    critBox.selectedIndex = -1;
    gbPref.setCharPref("history", "");
    
    // When the history is cleared all highlighting must be removed
    googlebarCheckHighlight("");
}

function googlebarAddTerm(term)
{
    var critBox = document.getElementById("googlebarCriteria");
    var mySearchTermBox = document.getElementById("googlebarSearchTerms");
    var mySearchTermMenu = document.getElementById("searchterms-menu");
    var mySearchTermPopup = document.getElementById("searchterms-popup");
    var myTerms = googlebarFindTerms(term);
    var tempNode, tempValue;
    var searchTermWidth = 0;
    var availableWidth = googlebarAvailableWidth();
    mySearchTermBox.setAttribute("googlebaroverflow",false);
    var overflow = false;

    for (var i = 0; i < myTerms.length; i++) {
        tempNode = document.createElement("text");
        tempNode.setAttribute("value", myTerms[i]);
        //tempNode.setAttribute("className", "googleBarSearchTerm");
        tempNode.className = "googleBarSearchTerm";
        tempValue = myTerms[i].replace(/\\/, "\\\\");
        tempNode.setAttribute("onclick", "googlebarFindInPage(\"" + tempValue + "\")");
        if (gbHighlightOn) {
            // for some reason, the following line does not work (the style attribute is set 
            // but not honored by mozilla), so we have to use a global class
            // tempNode.setAttribute("style", "background-color:" + termColor[i%10]);
            tempNode.className = "googleBarSearchTerm coloredSearchTerm"+(i%10);
            
        }
        mySearchTermBox.appendChild(tempNode);
        searchTermWidth = mySearchTermBox.boxObject.width;

        // check if buttons fit, if not, remove the last button
        // and add it to the overflow menu
        if (searchTermWidth > availableWidth) {
            mySearchTermPopup.appendChild(tempNode);
            mySearchTermMenu.setAttribute("hidden",false);
            overflow = true;
            mySearchTermBox.setAttribute("googlebaroverflow",true);
        }
        else {
            if (mySearchTermBox.getAttribute("googlebaroverflow")=="false") {
                mySearchTermMenu.setAttribute("hidden",true);
            }
        }
    }

    if (myTerms.length > 0) {
      document.getElementById("highlight-button").setAttribute("disabled", false);
    }
}

function googlebarCheckHighlight(critValue)
{
    var myTerms = googlebarFindTerms(critValue);
    var myHighlightButton = document.getElementById("highlight-button");
    
    if (myTerms.length > 0) {
        if (gbHighlightOn) {
            googlebarHighLightInPage("on");
        }
        myHighlightButton.setAttribute("disabled", false);
    }
    else {
        if (gbHighlightOn) {
            googlebarHighLightInPage("off");
            gbHighlightOn = false;
        }
        myHighlightButton.setAttribute("disabled", true);
    }
}

function googlebarCheckSearchbuttons()
{
    var critBox = document.getElementById("googlebarCriteria");
    googlebarClearTerms();
    googlebarAddTerm(critBox.value);
}

function googlebarAvailableWidth()
{
    // This function returns the width which is available for the
    // search term buttons
    var width=0;

    width += document.getElementById("google-menu").parentNode.boxObject.width;
    width -= document.getElementById("google-menu").boxObject.width;
    width -= document.getElementById("search-textbox").boxObject.width;
    width -= document.getElementById("resize-splitter").boxObject.width;
    width -= document.getElementById("googlebar-buttons").boxObject.width;
    return width;
}

function googlebarClearCrit()
{
    var critBox = document.getElementById("googlebarCriteria");
    critBox.value = "";
}

function googlebarClearTerms()
{
    var termBox = document.getElementById("googlebarSearchTerms");
    var termPopup = document.getElementById("searchterms-popup");
    for (var numTerms = termBox.childNodes.length; numTerms > 0; numTerms--) {
        termBox.removeChild(termBox.childNodes[0]);
    }
    for (numTerms = termPopup.childNodes.length; numTerms > 0; numTerms--) {
        termPopup.removeChild(termPopup.childNodes[0]);
    }
    termBox.setAttribute("googlebaroverflow",false);
}

function googlebarUp(event)
{
    if (ignoreUpDir) {
        ignoreUpDir = false;
        return;
    }

    var mode;
    var win = window._content.document;

    var upContainer = document.getElementById("up-dir-popup");

    if (upContainer && upContainer.childNodes.length > 0) {
        googlebarDoAction(upContainer.childNodes.item(0).getAttribute("label"), googlebarGetLocFromEvent(event));
    }
}

function blockBubble(bool)
{
    if (bool) {
        var temp=setTimeOut("blockBubble", 500);
    }
    else {
        loading = false;
    }
}

function googlebarHideItem(event)
{
    var item = event.target;
    var ggbItem = item.getAttribute("googlebaritem");
    var ggbButton, ggbMenuitem;

    ggbButton = document.getElementById(ggbItem );
    ggbButton.setAttribute("hidden", !item.getAttribute("checked"));

    if (hideMenuOption && ggbItem.indexOf("-separate") > 0) {
        ggbItem = ggbItem.replace("-separate", "");
        ggbMenuitem = document.getElementById(ggbItem);

        if (ggbMenuitem) {
            ggbMenuitem.setAttribute("hidden", item.getAttribute("checked"));
        }
    }

    googlebarCheckSearchbuttons();
}

function googlebarLabels(event)
{
    if (event.target.getAttribute("checked")) {
        googlebarLabelsOn();
    }
    else {
        googlebarLabelsOff();
    }
}

function googlebarLabelsOn()
{
    var container = document.getElementById("googlebar-buttons");
    var containerButtons = container.getElementsByTagName("toolbarbutton");

    for (var i = 0; i < containerButtons.length; i++) {
        containerButtons[i].setAttribute("label", containerButtons[i].getAttribute("buttonlabel"));
        updateElementClass(containerButtons[i], 0, "button-labeled");
    }
}

function googlebarLabelsOff()
{
    var container = document.getElementById("googlebar-buttons");
    var containerButtons = container.getElementsByTagName("toolbarbutton");

    for (var i = 0; i < containerButtons.length; i++) {
        containerButtons[i].removeAttribute("label");
        updateElementClass(containerButtons[i], 0, containerButtons[i].getAttribute("buttonclass"));
    }
}


function googlebarFindInPage(str)
{
  /* This is shamelessly taken from Firebird findUtils.js */
  var found = false;
  var focusedWindow = document.commandDispatcher.focusedWindow;
  if (!focusedWindow || focusedWindow == window)
    focusedWindow = window._content;
  var findInst = getBrowser().webBrowserFind;
  var findInFrames = findInst.QueryInterface(Components.interfaces.nsIWebBrowserFindInFrames);
  findInFrames.rootSearchFrame = window._content;
  findInFrames.currentSearchFrame = focusedWindow;

  // setup the find instance
  findInst.searchString  = str;

  // we hardcode the search options here with what seems to make most sense
  findInst.searchFrames = true;
  findInst.matchCase     = false;
  findInst.wrapFind      = true;
  findInst.entireWord    = false;
  findInst.findBackwards = false;
  
  // search
  found = findInst.findNext();

  if (!found) {
    alert(str + ' ' + document.getElementById("bundle_googlebar").getString("gb.notfound"));
  }
}

function googlebarRefreshHighlight()
{
    var hiBtn = document.getElementById("highlight-button");
    hiBtn.click();
    hiBtn.click();
}

function googlebarHighLightInPage(override)
{
    // Initialize to current document
    var gTheDocument = window._content.document;
    var critBox = document.getElementById("googlebarCriteria");
    var term = critBox.value;

    if (gbHighlightOn) {
        gbHighlightOn = false;
        highlightDoc(null, null);
        googlebarCheckSearchbuttons();
        // Exit if the term had not changed
        //  => means that the user clicked to remove highlighting
        if (gHighlightString == term  && override != "on") {
            return;
        }
    }

    gbHighlightOn = true;
    gHighlightString = term;

    // wanted to use selection to extend to the word
    // and compare with the found range, in order to match
    // only whole words
    
    // Save selection
/*
    gSelection = window._content.getSelection();
    gSaveSelection = new Array();
    for (var i = 0; i < gSelection.rangeCount; i++) {
        gSaveSelection.push(gSelection.getRangeAt(i));
    }
    gSelection.removeAllRanges();
*/
    var myTerms = googlebarFindTerms(term);
    for (var i = 0; i < myTerms.length; i++) {
        highlightDoc(myTerms[i], termColor[i %10]);
    }
/*
    // Revert to previous selection
    gSelection.removeAllRanges();
    for (var i = 0; i < gSaveSelection.length; i++) {
        gSelection.addRange(gSaveSelection[i]);
    }
*/
    googlebarCheckSearchbuttons();
}

function highlightDoc(word, color, win)
{
    if (!win) {
        // This appears to only highlight the current tab.
        // Rather than grab _content we can get the window
        // itself and highlight all the tabs at once.
        //
        // win = window._content;
        win = window.self;
    }

    for (var i = 0; win.frames && i < win.frames.length; i++) {
        highlightDoc(word, color, win.frames[i]);
    }

    var doc = win.document;
    if (!document) {
        return;
    }

    // Remove highligthing
    if (!color) {
        var elem = null;
        while ((elem = doc.getElementById("google-search-id"))) {
            var child = null;
            var docfrag = doc.createDocumentFragment();
            var next = elem.nextSibling;
            var parent = elem.parentNode;
            while((child = elem.firstChild)) {
                docfrag.appendChild(child);
            }
            parent.removeChild(elem);
            parent.insertBefore(docfrag, next);
        }
        return;
    }


    if (!("body" in doc)) {
        return;
    }
    var body = doc.body;
   
    var count = body.childNodes.length;
    searchRange = doc.createRange();
    startPt = doc.createRange();
    endPt = doc.createRange();

    var baseNode = doc.createElement("span");
    baseNode.setAttribute("style", "background-color: " + color + ";");
    baseNode.setAttribute("id", "google-search-id");

    searchRange.setStart(body, 0);
    searchRange.setEnd(body, count);

    startPt.setStart(body, 0);
    startPt.setEnd(body, 0);
    endPt.setStart(body, count);
    endPt.setEnd(body, count);
    highlightText(word, baseNode);
}

function highlightText(word, baseNode)
{
    var retRange = null;
    while((retRange = gFinder.Find(word, searchRange, startPt, endPt))) {
        // check that we have a whole word
        //gSelection.addRange(range);

        // Highlight
        var nodeSurround = baseNode.cloneNode(true);
        var node = highlight(retRange, nodeSurround);
        startPt = node.ownerDocument.createRange();
        startPt.setStart(node, node.childNodes.length);
        startPt.setEnd(node, node.childNodes.length);
    }
}

function highlight(range, node)
{
    var startContainer = range.startContainer;
    var startOffset = range.startOffset;
    var endOffset = range.endOffset;
    var docfrag = range.extractContents();
    var before = startContainer.splitText(startOffset);
    var parent = before.parentNode;
    node.appendChild(docfrag);
    parent.insertBefore(node, before);
    return node;
}

function updateUp()
{
    if (!window._content.document) {
        return;
    }

    var currentAddy = (queryStringOption) ? window._content.document.location.href.split("?")[0] : window._content.document.location.href;
    var arCurrentAddy = currentAddy.split("/");
    var tempNode = false;
    var curPath = false;
    var i;

    // Remove old instances
    var upContainer = document.getElementById("up-dir-popup");
    for (i = upContainer.childNodes.length - 1; i >= 0; i--) {
        upContainer.removeChild(upContainer.childNodes.item(i));
    }

    // Add new instances
    for (i = arCurrentAddy.length - 1; i > 2; i--) {

        if (arCurrentAddy[i].length) {
            curPath = buildUrl(arCurrentAddy, i);
            tempNode = document.createElement("menuitem");
            tempNode.setAttribute("label", curPath);
            tempNode.setAttribute("class", "menuitem-all");
            tempNode.setAttribute("oncommand", "upGo(event, '" + curPath + "');");
            tempNode.setAttribute("tooltiptext", curPath);
            upContainer.appendChild(tempNode);
        }
    }

    // If we are not at the default web host (www) then add that
    // host to the bottom of the list as Google toolbar does
    //
    // e.g. toolbar.google.com has www.google.com listed on "up" popup menu

    if (arCurrentAddy.length>=3)
    {
        var currentHost = arCurrentAddy[2];
        var arHost = currentHost.split(".");

        if (arHost.length == 3 && arHost[0] != "www") {
            var wwwHost = arCurrentAddy[0] + "//www" + "."  + arHost[1] + "." + arHost[2];
            tempNode = document.createElement("menuitem");
            tempNode.setAttribute("label", wwwHost);
            tempNode.setAttribute("class", "menuitem-all");
            tempNode.setAttribute("oncommand", "upGo(event, '" + wwwHost + "');");
            tempNode.setAttribute("tooltiptext", wwwHost);
            upContainer.appendChild(tempNode);
        }
    }

    if (upContainer.childNodes.length > 0) {
        document.getElementById("up-dir-button").setAttribute("disabled", false);
    }
    else {
        document.getElementById("up-dir-button").setAttribute("disabled", true);
    }
}

function updateUniv()
{
    window._content.document.location = "http://www.google.com/options/universities.html";
    populateUniv = true;
    // setTimeout("reallyUpdateUniv()", 2000);
}

function reallyUpdateUniv()
{
    populateUniv = false;
    var univID = "univ-popup";
    var univMenu;
    var univPopup;

    // Remove old instances
    var univContainer = document.getElementById(univID);
    for (var i = 3; i < univContainer.childNodes.length; i++) {
        univMenu = univContainer.childNodes.item(i);
        univPopup = univMenu.childNodes.item(0);
        for (var j = univPopup.childNodes.length - 1; j >= 0; j--) {
            univPopup.removeChild(univPopup.childNodes.item(j));
        }
    }

    var doc = window._content.document.documentElement;
    var aElems = doc.getElementsByTagName("A");
    var aData;
    var aHref;
    var startsWith;
    var tempNode;

    for (var k = 0; k < aElems.length; k++) {
        aHref = aElems[k].getAttribute("href");
        if (aHref) {
            if (/^\s*http:\/\/www.google.com\/univ\/(.*)/i.test(aHref)) {
                aData = aElems[k].firstChild.data;
                aData = aData.replace(/\s+/g, " ");
                // aData = data.replace(/[\t\n\r ]+/g, " ");
                startsWith = aData.substring(0, 1).toLowerCase();

                univPopup = document.getElementById(univID + "-" + startsWith);

                if (univPopup) {
                    tempNode = document.createElement("menuitem");
                    tempNode.setAttribute("label", aData);
                    tempNode.setAttribute("class", "menuitem-all");
                    tempNode.setAttribute("oncommand", "setUniv('" + aHref + "', '" + aData + "');");
                    tempNode.setAttribute("tooltiptext", aHref);
                    univPopup.appendChild(tempNode);
                }
            }
        }
    }
    alert(document.getElementById("bundle_googlebar").getString("gb.button.univ.done"));
}

function ignoreUnivGo()
{
    ignoreUniv = true;
}

function setUniv(url, name)
{
    var univBtn;

    univBtn = document.getElementById("univ-button");
    univBtn.removeAttribute("oncommand");
    univBtn.setAttribute("onclick", "if (event.button == 1) { univGo(event, '" + url + "') }");
    univBtn.setAttribute("oncommand", "univGo(event, '" + url + "');");
    univBtn.setAttribute("tooltiptext", document.getElementById("bundle_googlebar").getString("gb.button.univ") + " - " + name);

    university = url;
    gbPref.setCharPref("university", url);
    gbPref.setCharPref("universityName", name);
}

function univGo(event)
{
    if (ignoreUniv) {
        ignoreUniv = false;
        return;
    }

    if (!university) {
        alert(document.getElementById("bundle_googlebar").getString("gb.button.univ.none"));
    }
    else {
        googlebarSearch(event, "university");
    }
}

function buildUrl(pathArray, offset)
{
    var mystr = '';
    for (var i = 0; i < offset; i++) {
        if (pathArray[i].length) {
            mystr += pathArray[i];
            if (i < (offset-1)) {
              if (i == 0)                      
                if (pathArray[i] == "file:")
                  mystr += "/";             
              mystr += "/";
              // if it's the first item (protocol) then add a second /
              if (i == 0) mystr += "/";
            }
        }
    }

    // append trailing slash 
    mystr += "/";

    return mystr;
}

function upGo(event, addy)
{
    // ignore the googlebarUp called by the
    // oncommand event of the up button
    ignoreUpDir = true;

    googlebarDoAction(addy, googlebarGetLocFromEvent(event));
}

///////////////////////////////////////////////////////////////////////////////
/////////////////////// Some helper functions /////////////////////////////////

function isIn(arr, str)
{
    for (var i = 0; i < arr.length; i++) {
        if (arr[i].toLowerCase() == TrimString(str.toLowerCase())) {
            return true;
        }
    }
    return false;
}

function TrimString(string)
{
    if (!string) return "";
    return string.replace(/(^\s+)|(\s+$)/g, '');
}

function normalizeString(string)
{
    if (!string) return "";
    var newString = "";

    // trim leading and trailing spaces
    newString = string.replace(/(^\s+)|(\s+$)/g, '');

    // reduce runs of more than one space to one space only
    newString = newString.replace(/(\s+)/g, ' '); // a space

    return newString;
}

function googlebarCriteriaFocus()
{
    var critBox = document.getElementById("googlebarCriteria");
    critBox.focus();
}

function getFocusedElement() {
  var ff = document.getElementsByAttribute("focused",true);
  return ff.length ? ff[0] : null;
}

// Stateful Show/Focus: interact with the GoogleBar given its current state
// using a single keyboard shortcut.  The possible state transitions are
//
//  - If the toolbar is hidden, toggle (show) it and focus on the criteria box
//
//  - If the criteria box is in focus and ...
//     - ... it has no text, fill in and select a default tooltip
//     - ... it has less than all of its text selected, select all its text
//     - ... it has all of its text selected, toggle (hide) the toolbar
//
//  - If the criteria box is blurred, then focus on it
//
// Before focus is given to the criteria box, the element with the current
// focus is saved.  When the toolbar is then later hidden, focus is restored
// to that saved element.

function googlebarStatefulShowFocus() {

  var googlebar = document.getElementById( "googlebar" );
  var critBox = document.getElementById( "googlebarCriteria" );

  if( googlebar.hidden ) {

    gStatefulPrevFocus = getFocusedElement();
    goToggleToolbar( "googlebar", "cmd_googlebarShowHide" );
    critBox.focus();

  } else if( critBox.getAttribute("focused") ) {

    if( critBox.inputField.textLength == 0 ) {

      critBox.value = "GoogleBar \"Enter your search text\"";
      critBox.inputField.select();

    } else {

      var curClickStart = critBox.inputField.selectionStart;
      var curClickEnd = critBox.inputField.selectionEnd;
      var curSelSize = curClickEnd - curClickStart;

      if( curSelSize < critBox.inputField.textLength ) {

	critBox.inputField.select();

      } else {

	if( gStatefulPrevFocus != null ) { gStatefulPrevFocus.focus(); }
	else { window.content.focus(); }
	goToggleToolbar( "googlebar", "cmd_googlebarShowHide" );

      }
    }

  } else {

    gStatefulPrevFocus = getFocusedElement();
    critBox.focus();

  }
}

function googlebarCriteriaSelect(event)
{
    var critBox = document.getElementById("googlebarCriteria");
    var ePt = critBox.inputField.textLength;
    var curClickStart = critBox.inputField.selectionStart;
    var curClickEnd = critBox.inputField.selectionEnd;
    var curSelSize = curClickEnd - curClickStart;

    if (event && ePt > 0) {
        switch(event.type) {

        case "dblclick":
            if (!boolCritSelected) {
                critBox.inputField.select();
                boolCritSelected = true;
            }
            else {
                critBox.inputField.setSelectionRange(curClickStart, curClickEnd);
                boolCritSelected = false;
            }
            break;

        case "focus":
            if (critIgnoreFocus) {
                critIgnoreFocus = false;
            }
            else {
                if (boolCritSelected) {
                    if (hkeytgl) {
                        critBox.inputField.setSelectionRange(0, 0 );
                        boolCritSelected = false;
                    }
                    else {
                        critBox.inputField.select();
                    }
                }
                else {
                    critBox.inputField.select();
                    boolCritSelected = true;
                }
            }
            break;

        case "mousedown":
            if (critBox.getAttribute("focused")) {
                critIgnoreClick = true;
            }
            else {
                critIgnoreFocus = true;
                critIgnoreClick = false;
                critBox.inputField.setSelectionRange(0, 0 );
                boolCritSelected = true;
            }
            break;

        case "click":
            if (!critIgnoreClick && curSelSize == 0) {
                critBox.inputField.select();
                boolCritSelected = true;
            }
            break;

        default:
            break;

        }
    } // no event or text
}

function googlebarGoPopupMenus()
{
    var ggbPopupInUse = document.getElementById("googlebar-buttons");

    googlebarSyncMainPopup("search-separate", "SearchButtonItem");
    googlebarSyncMainPopup("site-separate", "SiteButtonItem");
    googlebarSyncMainPopup("lucky-separate", "LuckyButtonItem");
    googlebarSyncMainPopup("images-separate", "ImagesButtonItem");
    googlebarSyncMainPopup("groups-separate", "GroupsButtonItem");
    googlebarSyncMainPopup("directory-separate", "DirectoryButtonItem");
    googlebarSyncMainPopup("news-separate", "NewsButtonItem");
    googlebarSyncMainPopup("answers-separate", "AnswersButtonItem");

    googlebarSyncMainPopup("catalog-separate", "CatalogButtonItem");
    googlebarSyncMainPopup("froogle-separate", "FroogleButtonItem");
    googlebarSyncMainPopup("stocks-separate", "StocksButtonItem");
    googlebarSyncMainPopup("unclesam-separate", "UnclesamButtonItem");
    googlebarSyncMainPopup("viewer-separate", "ViewerButtonItem");
    googlebarSyncMainPopup("webquotes-separate", "WebquotesButtonItem");
    googlebarSyncMainPopup("dictionary-separate", "DictionaryButtonItem");
    googlebarSyncMainPopup("glossary-separate", "GlossaryButtonItem");

    googlebarSyncMainPopup("bsd-separate", "BsdButtonItem");
    googlebarSyncMainPopup("linux-separate", "LinuxButtonItem");
    googlebarSyncMainPopup("mac-separate", "MacButtonItem");
    googlebarSyncMainPopup("microsoft-separate", "MicrosoftButtonItem");

    googlebarSyncMainPopup("cached-separate", "CachedButtonItem");
    googlebarSyncMainPopup("similar-separate", "SimilarButtonItem");
    googlebarSyncMainPopup("backwards-separate", "BackwardsButtonItem");
    googlebarSyncMainPopup("translate-separate", "TranslateButtonItem");

    googlebarSyncMainPopup("spec-menu", "SpecButtonItem");
    googlebarSyncMainPopup("comp-menu", "CompButtonItem");
    googlebarSyncMainPopup("univ-button", "UnivButtonItem");
    googlebarSyncMainPopup("extras-box", "ExtrasButtonItem");
    googlebarSyncMainPopup("info-menu", "InfoButtonItem");
    googlebarSyncMainPopup("up-dir-button", "UpDirButtonItem");
    googlebarSyncMainPopup("nav-box", "NavButtonItem");
    googlebarSyncMainPopup("highlightplus-button", "HighlightPlusButtonItem");
    googlebarSyncMainPopup("highlight-button", "HighlightButtonItem");
    googlebarSyncMainPopup("googlebarSearchTerms", "SearchTermsButtonItem");

    var element = document.getElementById("OrderLockButtonItem");
    if (element.getAttribute("checked") == "true") {
        lockOrdinalOrder();
    }
    else {
        unlockOrdinalOrder();
    }
}

function googlebarSyncMainPopup(src, dest)
{
    var ggbButtonState = document.getElementById(src);
    var ggbPopupChecked = document.getElementById(dest);

    ggbPopupChecked.setAttribute("checked", !(ggbButtonState.getAttribute("hidden") == "true"));

    if (hideMenuOption && src.indexOf("-separate") > 0) {
        var ggbItem = src.replace("-separate", "");
        var ggbMenuitem = document.getElementById(ggbItem);

        if (ggbMenuitem) {
            ggbMenuitem.setAttribute("hidden", !(ggbButtonState.getAttribute("hidden") == "true"));
        }
    }
}

function googlebarSyncMenuButton(ggbButton, ggbOption)
{
    // If there was a previous search selected for the
    // menu button and the preference is set to save
    // these settings then attempt to restore the
    // selection, if possible, otherwise just ignore it

    if (!saveLastOption) {
        return;
    }

    var optionValue;

    try {
        optionValue = gbPref.getCharPref(ggbOption);
    }
    catch(e) {
        gbPref.setCharPref(ggbOption, "");
        optionValue = "";
    }

    var menuButton = document.getElementById(ggbButton);
    var separateButton = document.getElementById(optionValue + "-separate");

    if (!menuButton || !separateButton) {
        return;
    }

    menuButton.removeAttribute("oncommand");
    menuButton.setAttribute("oncommand", separateButton.getAttribute("oncommand"));

    menuButton.setAttribute("buttonclass", separateButton.getAttribute("buttonclass"));
    menuButton.setAttribute("buttonlabel", separateButton.getAttribute("buttonlabel"));
    menuButton.setAttribute("class", separateButton.getAttribute("class"));

    if (separateButton.getAttribute("label")) {
        menuButton.setAttribute("label", separateButton.getAttribute("label"));
    }
}

function googlebarCriteriaTooltip()
{
    var critBox = document.getElementById("googlebarCriteria");

    if (critBox.value) {
        critBox.tooltipText = critBox.value;
    }
    else {
        critBox.tooltipText = critBox.statusText;
    }
}

function srchFlipflop()
{
    var ggbsrchterms = document.getElementById("googlebarSearchTerms");
    var searchTermMenu = document.getElementById("searchterms-menu");
    ggbsrchterms.setAttribute("hidden", !ggbsrchterms.hidden );

    // when we are overflowing, set the hidden status of the overflow
    // menu accordingly
    if (ggbsrchterms.getAttribute("googlebaroverflow")=="true") {
        searchTermMenu.setAttribute("hidden", ggbsrchterms.hidden );
    }

    // when the search buttons were unhidden, we have to check
    // if they fit
    if (!ggbsrchterms.hidden) {
        googlebarCheckSearchbuttons();
    }
    return true;
}

function setGoogleContextMenu()
{
    // our broadcaster doesn't get implemented in phoenix, and this error
    // prevents readprefs in phoenix from completing, and then it just uses defaults.
    // tried mainBroadcasterset instead of navBroadcasterset which didn't work.

    var inPrefs = false;
    var cntxtmnuopt;

    var cntxtmnu = document.getElementById('googlebar_contextpref');
    if (!cntxtmnu) {
        cntxtmnu = top.opener.document.getElementById('googlebar_contextpref');
        inPrefs = true;
    }

    if (inPrefs) {
        cntxtmnuopt = document.getElementById('contextmenuoption').checked;
    }
    else {
        cntxtmnuopt = gbPref.getBoolPref("contextmenuoption");
    }

    if (cntxtmnuopt) {
        cntxtmnu.setAttribute('hidden', false);
    }
    else {
        cntxtmnu.setAttribute('hidden', true);
    }
}

function cntrySfxsInit()
{
    for (var i = 0; document.getElementById("bundle_googlebar").getString("gb.country." + i) != "endoflist"; i++) {
        cntrySfxs[i] = document.getElementById("bundle_googlebar").getString("gb.country." + i);
    }
}

function cntryNewsSfxsInit()
{
    for (var i = 0; document.getElementById("bundle_googlebar").getString("gb.news.country." + i) != "endoflist"; i++) {
        cntryNewsSfxs[i] = document.getElementById("bundle_googlebar").getString("gb.news.country." + i);
    }
}

function selectGgbCountry(cntry)
{
    if (cntry) {
        gbPref.setIntPref("country2Search", cntry);
        cntry2SrchIx = cntry;
        cntry2Srch = cntrySfxs[cntry2SrchIx];
    }
    else {
        alert(document.getElementById("bundle_googlebar").getString("gb.country.none"));
    }
}

function selectGgbCountryNews(cntry)
{
    if (cntry) {
        gbPref.setIntPref("countryNews2Search", cntry);
        cntryNews2SrchIx = cntry;
        cntryNews2Srch = cntryNewsSfxs[cntryNews2SrchIx];
    }
    else {
        alert(document.getElementById("bundle_googlebar").getString("gb.news.country.none"));
    }
}

function setMaxHistCnt(cnt)
{
    if (cnt) {
        gbPref.setIntPref("maxHistCnt", cnt);
    }
    else {
        alert(document.getElementById("bundle_googlebar").getString("gb.error.max_hist"));
        gbPref.setIntPref("maxHistCnt", 10);
    }
    maxHistCnt = gbPref.getIntPref("maxHistCnt");
}

function googlebarOpenPrefs()
{
    if (inFirebird) {
        window.openDialog('chrome://googlebar/content/googlebarPrefDialog.xul', 'Phoogle', 'chrome');
    }
    else {
        goPreferences('googlebarItem', 'chrome://googlebar/content/pref/pref-googlebar1.xul', 'googlebarItem');
    }
}

function googlebarOpenGooglePrefs()
{
    window._content.document.location = 'http://www.google.' + cntry2Srch + '/preferences';
}

function googlebarUpdateParent(event)
{
    if (!saveLastOption) {
        return;
    }

    var menuButton = event.target.parentNode.parentNode;
    var separateButton = document.getElementById(event.target.getAttribute("id") + "-separate");

    menuButton.removeAttribute("oncommand");
    menuButton.setAttribute("oncommand", separateButton.getAttribute("oncommand"));

    menuButton.setAttribute("buttonclass", separateButton.getAttribute("buttonclass"));
    menuButton.setAttribute("buttonlabel", separateButton.getAttribute("buttonlabel"));
    menuButton.setAttribute("class", separateButton.getAttribute("class"));

    if (separateButton.getAttribute("label")) {
        menuButton.setAttribute("label", separateButton.getAttribute("label"));
    }

    if (menuButton.getAttribute("id") == "comp-menu") {
        gbPref.setCharPref("lastCompSearch", event.target.getAttribute("id"));
    }
    else if (menuButton.getAttribute("id") == "info-menu") {
        gbPref.setCharPref("lastInfoSearch", event.target.getAttribute("id"));
    }
    else if (menuButton.getAttribute("id") == "spec-menu") {
        gbPref.setCharPref("lastSpecSearch", event.target.getAttribute("id"));
    }
    else {
        alert("Don't know how to handle menu button " + menuButton.getAttribute("id"));
    }
}

function updateElementClass(element, position, newClass)
{
    var oldClass = element.getAttribute("class");
    var classes = oldClass.split(" ");
    classes[position] = newClass;
    element.setAttribute("class", classes.join(" "));
}

function googlebarShowPopup(event)
{
    if ((event.target.getAttribute("type") == "menu" || event.target.getAttribute("type") == "menu-button") && event.target.firstChild)
    {
      event.target.firstChild.showPopup();
    }
}

function googlebarUpdateNewWindow() {
  // This method is used to update the current search terms 
  // from another window. This should happen when
  // 1. a new window is opened for the first time (called from
  //    googlebarDisplayCheck()
  // 2. a google 

  var otherCriteria = null;
  var thisCriteria = document.getElementById("googlebarCriteria");

  // If this window was opened from another window, just use
  // the criteria from the opener
  if (window.opener) {
    if (!openerUpdated) {
      otherCriteria = window.opener.document.getElementById("googlebarCriteria");
    }
    openerUpdated = true;    
  }
  else {
    // window had not opener, so get the criteria from somewhere else
    const MEDIATOR_CONTRACTID = "@mozilla.org/appshell/window-mediator;1";
    const nsIWindowMediator = Components.interfaces.nsIWindowMediator;
    var windowManager = 
      Components.classes[MEDIATOR_CONTRACTID].getService(nsIWindowMediator);
    
    var openwindows = windowManager.getEnumerator(null);
    var win=null;
    
    // check all open windows for googlebarCriteria
    // this will always get the search terms of the last window
    // in the list, this might not be the last window which was
    // selected, so this might not always give the expected result
    // (but who needs multiple windows anyway when you have tabs?)
    while (openwindows.hasMoreElements()) {
      win = openwindows.getNext();

      if (win != window) {
        otherCriteria = win.document.getElementById("googlebarCriteria");
        if (win.document.getElementById("googlebarCriteria") != null)
        {
          otherCriteria = win.document.getElementById("googlebarCriteria");
        }
      }
    }
  }

  if (otherCriteria && thisCriteria) {
    thisCriteria.value = otherCriteria.value;
  }
}

